#include <GL/glut.h> //glut library, it imports gl.h, glu.h
#include <stdlib.h> //for exit call

#define ESCAPE 27 //define ASCII value for escape keystroke

/*
=================
display()
-Renders output to screen
=================
*/
void display(void)
{
	/* set the clear colour - red, green, blue, alpha*/
	glClearColor(1.0, 0.0, 0.0, 0.0);
	/* clear frame buffer and depth-buffer */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	/* make sure all previously issued commands are completed */
	glFlush(); 
	/* contents of back buffer are set to become that of front buffer (double buffering)*/
	glutSwapBuffers();
}

/*
=================
keys
-handles all normal keyboard input
==================
*/
void keyboard(unsigned char key, int x, int y) 
{
	/* on pressing the escape key the program terminates */
	if (key == ESCAPE) //escape key handling code
	{
		exit(0); //exits the program
	}
}

/*
=================
keys
-handles all normal keyboard input
==================
*/
void mouse(int button, int state, int x, int y) 
{
	/* on pressing the right mouse button the program terminates */
	if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
	{
		exit(0); //exits the program
	}
}

/*
=================
main
=================
*/
int main(int argc, char** argv)
{
	/* initialize the GLUT library. */
	glutInit(&argc, argv);
	
	/* set the initial display mode: double buffering and a
	   depth buffer. */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	
	/* set default window size */
	glutInitWindowSize(400, 300);
	
	/* create a top-level window with a caption */
	glutCreateWindow("Setting up a GLUT/OpenGL Window");
	
	/* set the mouse callback for the current window */
	glutMouseFunc(mouse);
	
	/* set the keyboard callback for the current window.*/
	glutKeyboardFunc(keyboard);
	
	/* display our contents in the window */
	
	glutDisplayFunc(display);
	/* enter the GLUT event processing loop - will handle
	   any callback */
	glutMainLoop();
	
	return 0;
}